
	.title  "display"	; Titolo del programma 
	.vers   "ST62E25"  	; Microprocessore usato  
	.w_on             	; Abilita la memoria a finestre
	;       4 Mhz		; 08/03/98 by Vittorio Crapella 
;----------------------------------------
;|   VARIABILI DEL MICROPROCESSORE      |
;----------------------------------------

a       .def    0ffh    ;Registro accumulatore
x       .def    080h    ;Registro x 
y       .def    081h    ;Registro y
v       .def    082h    ;Registro v
w       .def    083h    ;Registro w
port_a  .def    0c0h    ;Registro Dati porta A 
port_b  .def    0c1h    ;Registro Dati porta B
port_c  .def    0c2h    ;Registro Dati porta C
pdir_a  .def    0c4h    ;Registro Direzione porta A
pdir_b  .def    0c5h    ;Registro Direzione porta B
pdir_c  .def    0c6h    ;Registro Direzione porta C
popt_a  .def    0cch    ;Registro Opzioni porta A
popt_b  .def    0cdh    ;Registro Opzioni porta B
popt_c  .def    0ceh    ;Registro Opzioni porta C
ior     .def    0c8h    ;Registro Opzioni per le Interruzioni
addr    .def    0d0h    ;Registro Dati dell'A/D converter
adcr    .def    0d1h    ;Registro di Controllo dell'A/D converter
psc     .def    0d2h    ;Registro per il Prescaler del Timer
tcr     .def    0d3h    ;Registro Dati del Timer
tscr    .def    0d4h    ;Registro TSCR del Timer 
wdog    .def    0d8h    ;Registro del WatchDog
drw     .def    0c9h    ;Registro della zona dati ROM (Rom Data Window)
;--------------------------------------
; VARIABILI usate da questo PROGRAMMA |
;--------------------------------------
decimi	.def    084h	;display
unita	.def	085h	;"
decine	.def	086h	;"
resto	.def	087h	;divisione
risul	.def	088h
aa	.def	089h	
;fino a 	0bfh    massimo
;***************************
;***  Settaggio iniziale ***
;***************************
	.org    0880h      ; Significa: da qui in poi memorizziamo il
			   ; programma nella memoria ROM

inizio                     ; Inizializzazione del micro

	ldi     wdog,0ffh  

;***  Setta la porta A 
	ldi     pdir_a,11111111b        ;bit 7= A/D mettendo 0 in pdir
	ldi     popt_a,11111111b        ;bit 4/6=push pull 6= 0
	ldi     port_a,11111111b        ;bit 0/2 = input-out 
					;bit 0/2 = out opencol 0 con pdir a 1
;***  Setta la porta B 
	ldi     pdir_b,00000111b        ;bit 0=out a 0
	ldi     popt_b,00001111b        ;bit 4/7=out push-pull
	ldi     port_b,00001111b        ;bit 1/3= A/D mettendo 1 in popt

;***  Setta la porta C
	ldi     port_c,11110000b       
	ldi     pdir_c,11110000b        
	ldi     popt_c,11110000b        

;***  Disabilita gli Interrupt che non servono
	ldi     adcr,0         ;disabilita A/D interrupt
	ldi     tscr,0         ;disabilita TIMER interrupt
	ldi     ior, 0         ;disabilita TUTTI gli interrupt

	reti                    ; Alla fine della inizializzazione va messa
				; questa istruzione
	jp      main     	; Ora andiamo al programma principale "main"


;*****************************
;***  GESTORI di INTERRUPT ***
;*****************************

ad_int  reti
tim_int reti
BC_int  reti
A_int   reti
nmi_int reti

;*********************
;***   SUBROUTINE  ***
;*********************
display
	ld 	a,decimi		;cifra di destra DECIMALI
	ld 	port_a,a		;mette sulla porta i DECIMI
	ldi 	port_b,00001110b	;abilita trans. decimali
	call    delay
	ldi	port_b,00001111b	;disabilita tr decimali
	ld 	a,unita           	;cifra di sinistra UNITA`
	ld 	port_a,a		;mette sulla porta UNITA
	ldi	port_b,00001101b		;abilita transitore UNITA
	call    delay
	ldi	port_b,00001111b
	ld	a,decine		;DECINE
	ld	port_a,a		;mette sulla porta le DECINE
	ldi	port_b,00001011b		;abilita tr decine
	call	delay
	ldi	port_b,00001111b		;spegne decine
rito	ret				;ritorna

delay	ldi     y,100		;circa 2 mS di ritardo
decy	dec     y
	ldi	wdog,255
	jrnz	decy
	ret

			;DIVIDE x 10
subb	clr 	w
	ldi	wdog,255
	cpi 	a,10		;se a< div salta
	jrc	ok
sub_	subi 	a,10
	inc 	w
	ldi 	wdog,255
	cpi 	a,10
	jrnc 	sub_
ok	ld 	resto,a		;resto       UNITA
	ld 	a,w	 	;risultato
	ld 	risul,a 	;            DECINE
	ret

attendi res	4,ior		;disabilita interrup timer
	clr	resto
	clr	risul
	ldi 	aa,255
averr1	ldi	wdog,255
	ldi 	adcr,00110000b		;abilita A/D pb3
att	jrr	6,adcr,att
	nop
	ld	a,addr
	add	a,resto
	jrnc	averr2
	inc	risul
averr2	ld	resto,a
	ld	a,aa
	jrz	averr4
	dec 	aa		;se non ha fatto 255 conversioni
	call	display		;ad ogni conversione visualizza
	jp	averr1		;salta e continua a convertire
averr4	ld	a,resto
	cpi	a,127
	jrc	averr3
	inc	risul
averr3	ld	a,risul
	set	4,ior		;riabilita int. timer
	ret

;******************************************
;PROGRAMMA PRINCIPALE
;******************************************

main	ldi	wdog,255
	call 	attendi		;legge tensione
;	addi	a,2		;aggiustamento partitore
	call 	subb		;divide x 10	ex: 142:10=14
	ld 	decine,a	;salva risultato in decine
	ld	a,resto		;prende resto		=2
	ld 	decimi,a	;preara display DECIMALI  =2
	ld 	a,decine	;riprende val. decine =14
prepar2	call	subb		;divide x 10 = 1 decine e 2 unita
	cpi     a,0		;se risultato =0 allora DECINE=15 (spento)
	jrnz	deci
	ldi	a,15		;display spento
deci	ld 	decine,a
	ld      a,resto		;resto in UNITA
	ld 	unita,a		; decine  unita  decimi
	jp 	main

;*******************************
;***   VETTORI DI INTERRUPT  ***
;*******************************
	.org    0ff0h
	jp      ad_int  	;A/D int        vector #4
	jp      tim_int 	;timer int      vector #3
	jp      BC_int  	;port B & C int vector #2
	jp      A_int   	;port A int     vector #1
	.org    0ffch
	jp      nmi_int 	;nmi int        vector #0
	jp    	inizio  	;reset vector
	.end     		; Fine del programma
